<?php
class xml {
	var $parser;
	function parse($xmlstring){
		$this->parser = xml_parser_create();
		xml_set_object($this->parser, $this);
		xml_parser_set_option($this->parser, XML_OPTION_CASE_FOLDING, false);
		xml_set_element_handler($this->parser, "tag_open", "tag_close");
		xml_set_character_data_handler($this->parser, "cdata");

		// Build a Root node and initialize the node_stack...
        $this->node_stack = array();
        $this->tag_open(null, "root", array());

        // parse the data and free the parser...
        xml_parse($this->parser, $xmlstring);
        xml_parser_free($this->parser);

        // recover the root node from the node stack
        $rnode = array_pop($this->node_stack);

        // return the root node...
        return($rnode);
	}	
	function tag_open($parser, $tag, $attributes){
		// var_dump($parser, $tag, $attributes); uncoment to see if there's coming data
        // create a new node...
        $node = array();
        $node["_NAME"]      = $tag;
        foreach ($attributes as $key => $value) {
            $node[$key] = $value;
        }
        $node["_DATA"]      = "";
        $node["_ELEMENTS"]  = array();

        // add the new node to the end of the node stack
        array_push($this->node_stack, $node);		
	}

	function cdata($parser, $cdata){
		//var_dump($parser, $cdata);
		// add this data to the last node in the stack...
        $lastnode = count($this->node_stack);
        $this->node_stack[$lastnode-1]["_DATA"] .= $cdata;
	}
	function tag_close($parser, $tag){
		//var_dump($parser, $tag);
		// pop this element off the node stack
        $node = array_pop($this->node_stack);
        $node["_DATA"] = trim($node["_DATA"]);

        // and add it an an element of the last node in the stack...
        $lastnode = count($this->node_stack);
        array_push($this->node_stack[$lastnode-1]["_ELEMENTS"], $node);
	}
} // end of class xml
?>